# Graphviz - Graph Visualization Tools

from AT&T Research and Lucent Bell Labs
* http://www.graphviz.org/

See doc/build.html for prerequisites and detailed build notes.

## master GIT Repository

The master GIT Repository for graphviz can be found at:
* http://github.com/ellson/graphviz/

## Graph Visualization ( http://www.graphviz.org/About.php )

Graph visualization is a way of representing structural information as diagrams of abstract graphs and networks. It has important applications in networking, bioinformatics,  software engineering, database and web design, machine learning, and in visual interfaces for other technical domains.

Graphviz is open source graph visualization software. It has several main layout programs. See the gallery for sample layouts. It also has web and interactive graphical interfaces, and auxiliary tools, libraries, and language bindings. We're not able to put a lot of work into GUI editors but there are quite a few external projects and even commercial tools that incorporate Graphviz. You can find some of these in the Resources section.

The Graphviz layout programs take descriptions of graphs in a simple text language, and make diagrams in useful formats, such as images and SVG for web pages; PDF or Postscript for inclusion in other documents; or display in an interactive graph browser.

Graphviz has many useful features for concrete diagrams, such as options for colors, fonts, tabular node layouts, line styles, hyperlinks, and custom shapes.

In practice, graphs are usually generated from an external data sources, but they can also be created and edited manually, either as raw text files or within a graphical editor. (Graphviz was not intended to be a Visio replacement, so it is probably frustrating to try to use it that way.) 

## Contacts

If you have a bug or believe something is not working as expected, please submit a bug report ( http://www.graphviz.org/content/graphviz-issue-tracker ).

If you have a general question or are unsure how things work, please consider posting first to the Graphviz mailing list ( http://www.graphviz.org/MailingList.php ) or on the user forum ( http://www.graphviz.org/forums/general-discussion ). We follow these, but there are also many users who might be able to respond to you better or faster than we can. Please do not send detailed bug reports there.

John Ellson
